@echo off
ECHO -
ECHO ---
ECHO --------------------------------------------------------
ECHO Instalacja aktualizacji systemu Sage Symfonia
ECHO --------------------------------------------------------
ECHO ---
ECHO -
rem Skrypt instaluje dll z aktualnego katalogu do GAC'a
rem Katalog w którym jest skrypt
set SCRIPTDIR=%~dp0
rem Katalog w jakim jestesmy w konsoli w trakcie uruchamiania skryptu
set CURRENTDIR=%CD%

rem Opis poprawki
rem TYPE %SCRIPTDIR%ReadMe.txt

rem Wykrywanie wersji Windows
for /f "tokens=4-7 delims=[.] " %%i in ('ver') do (if %%i==Version (set WIN_VER=%%j.%%k) else (set WIN_VER=%%i.%%j))

REM Wykrywanie 64b vs 32b
reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT

echo Wersja systemu Windows: %WIN_VER%  %OS%

::list of Microsoft Windows versions.
::6.3  Windows 8.1 and Windows Server 2012 
::6.2  Windows 8 
::6.1  Windows 7 
::6.0  Windows Vista 
::5.2  Windows XP Professional x64 
::5.1  Windows XP 
::5.0  Windows 2000 
::4.10 Windows 98 

rem Wybór odpowiedniego gacutil'a
IF "%WIN_VER%"=="5.1" (
SET GACUTIL=Tools\gacutil\WinXP\gacutil.exe
) ELSE IF "%WIN_VER%"=="5.2" (
SET GACUTIL=Tools\gacutil\WinXP\gacutil.exe
) ELSE SET GACUTIL=Tools\gacutil\Win7\gacutil.exe

SET GACUTIL=%SCRIPTDIR%%GACUTIL%
REM ECHO %GACUTIL%

if %OS%==64BIT (
ECHO --------------------------------------------------------
echo EDK 2022.a
call :RegImpl "HKLM\SOFTWARE\WOW6432Node\Sage\Symfonia\22.1\EDK" InstallDir "2022.a"
)

if %OS%==32BIT (
ECHO --------------------------------------------------------
echo EDK 2022.a
call :RegImpl "HKLM\SOFTWARE\Sage\Symfonia\22.1\EDK" InstallDir "2022.a"
)

ECHO.
ECHO --------------------------------------------------------
ECHO --- Zakonczono aktualizacje ----------------------------
ECHO --------------------------------------------------------

echo.
echo Nacisnij dowolny klawisz . . .
pause
exit

:RegImpl
REM @echo OFF

setlocal ENABLEEXTENSIONS

set KEY_NAME="%~1"
set VALUE_NAME=%~2
set VERSION="%~3"
set FOUND=0

FOR /F "usebackq skip=2 tokens=1,2*" %%A IN (`REG QUERY %KEY_NAME% /v %VALUE_NAME% 2^>nul`) DO (
    if %%A==%VALUE_NAME% (
       Rem tutaj wiemy że zainstalowano w tej wesji
       Rem VERSION zawiera wersję (katalog) do podmiany, 
       Rem miejsce instalacji jest w %%C
       
       rem @echo Name = %%A
       rem @echo Type = %%B
       rem @echo InstallFolder = %%C
       set FOUND=1
       echo Znaleziono EDK w wersji %VERSION% w katalogu "%%C"	   
	   call :Install %VERSION% "%%C" %VERSION%
    )
)

if %FOUND%==0 (
   echo Nie znaleziono EDK w wersji %VERSION%
)

echo.   
echo Nacisnij dowolny klawisz . . .
pause
exit /b
echo ##########################################################
REM -----------------------------------------------------------

:Install
echo off
REM folder z którego instalujemy
set "SourceFolder=%~1"
set "DestinationFolder=%~2"
set "ExeVersion=%~3"

rem echo "%SCRIPTDIR%%SourceFolder%\Assemblies2GAC\"
rem echo "%DestinationFolder%"
rem echo "%ExeVersion%"
rem pause 

ECHO -
ECHO ---
ECHO -
ECHO Kopiowanie plikow do GAC:
ECHO -
echo cd /d "%SCRIPTDIR%%SourceFolder%\Assemblies2GAC\"
cd /d "%SCRIPTDIR%%SourceFolder%\Assemblies2GAC\"
echo /b *.*.dll > assemblyList
dir /b *.*.dll > assemblyList
rem instalowanie dll do GAC'a
"%GACUTIL%" /f /il assemblyList
IF errorlevel 1 GOTO error
del assemblyList

REM W tej wersji nie kopiujemy niczego do CommonProgramFiles
REM ECHO -
REM ECHO ---
REM ECHO -
REM ECHO Kopiowanie plikow do katalogow:
REM ECHO -
REM IF "%CommonProgramFiles(x86)%"=="" SET CommonProgramFiles(x86)=%CommonProgramFiles%

REM kopiowanie dll'ek do CommonFiles
REM xcopy "%SCRIPTDIR%%SourceFolder%\CommonFiles(x86)\*" "%CommonProgramFiles(x86)%\" /E /F /Y /R
REM IF errorlevel 1 GOTO error

REM kopiowanie dll'ek pod exe'ka aplikacji
ECHO -
ECHO ---
ECHO -
ECHO Kopiowanie plikow do katalogu aplikacji:
ECHO -
xcopy "%SCRIPTDIR%%SourceFolder%\*.dll" "%DestinationFolder%" /F /Y /R
IF errorlevel 1 GOTO error

goto ok
:error
ECHO -
ECHO ---
ECHO --------------------------------------------------------
ECHO UWAGA!
ECHO Aktualizacja wersji EDK '%ExeVersion%' NIE zostala zainstalowana.
ECHO Prosze uruchomic skrypt z prawami administratora.
ECHO --------------------------------------------------------
ECHO ---
ECHO -
EXIT /b

:ok
ECHO -
ECHO ---
ECHO --------------------------------------------------------
ECHO Aktualizacja dla wersji EDK '%ExeVersion%' zostala zainstalowana poprawnie
ECHO --------------------------------------------------------
ECHO ---
ECHO -
EXIT /b

::*******************************************************************
:GetFileNameFromPath <resultVar> <pathVar>
set "%~1=%~nx2"
exit /b
::*******************************************************************
:GetDirectoryFromPath <resultVar> <pathVar>
set "%~1=%~dp$PATH:2"
exit /b
::*******************************************************************
:GetVersion <ApplicationPath> <Version>
Rem The argument %~1 represente the full path of the application
Rem without the double quotes
Rem The argument %2 represente the variable to be set (in our case %2=Version)  
FOR /F "tokens=2 delims==" %%I IN (
  'wmic datafile where "name='%~1'" get version /format:Textvaluelist 2^>^nul'
) DO FOR /F "delims=" %%A IN ("%%I") DO SET "%2=%%A"
Exit /b
::*******************************************************************
:Add_backSlash <String>
Rem Subroutine to replace the simple "\" by a double "\\" into a String
Set "Application=%1"
Set "String=\"
Set "NewString=\\"
Call Set "Application=%%Application:%String%=%NewString%%%"
Exit /b
::*******************************************************************
:Remove_backSlash <String>
Rem Subroutine to replace the double "\\" by a simple "\" into a String
Set "Application=%1"
Set "String=\\"
Set "NewString=\"
Call Set "Application=%%Application:%String%=%NewString%%%"
Exit /b
::*******************************************************************
:Get_AppName <FullPath> <AppName>
Rem %1 = FullPath
Rem %2 = AppName
for %%i in (%1) do set "%2=%%~nxi"
exit /b
::*******************************************************************
:BuildLine
set "LineChar=%1"
if "%LineChar%"=="" set "LineChar=_"
for /f "tokens=2 skip=4" %%A in ('mode con: /status') do set "WindowColumns=%%A" & goto :GotColumnCount
:GotColumnCount
set "CharLine="
setlocal EnableDelayedExpansion
for /L %%A in (1,1,%WindowColumns%) do set "CharLine=!CharLine!!LineChar:~0,1!"
setlocal DisableDelayedExpansion
endlocal
echo %CharLine%
goto :eof
::*******************************************************************


